      subroutine calcu
     &(im,ik,kc,x,y,z,vx,vy,vz,fx,fy,fz,wm,pl,uk,xl,yl,zl,dt)
      include 'para.inc'
      parameter(epsilon=1.625D-21/ev,sigma=3.504d0)
c*******force calculation (not use if sentense) LJ potential*********
      dimension x(im),y(im),z(im)
      dimension vx(im),vy(im),vz(im)
      dimension fx(im),fy(im),fz(im)
      dimension wm(im)
      dimension pl(6,im)
      dimension uk(im)
      dimension kc(kc1,kc2)
c****** local variables
      dimension rx(im),ry(im),rz(im)
      dimension fxp(im),fyp(im),fzp(im)
      dimension dx(im),dy(im),dz(im)
      dimension dvx(im),dvy(im),dvz(im)
c
c*****finite difference method*******
      do 299 i=1,im
       dx1 = vx(i)+fx(i)*dt/2.0d0/wm(i)
       dy1 = vy(i)+fy(i)*dt/2.0d0/wm(i)
       dz1 = vz(i)+fz(i)*dt/2.0d0/wm(i)
       dx(i)=dx1*dt
       dy(i)=dy1*dt
       dz(i)=dz1*dt
 299  continue
c
      do 289 i=1,im
        x(i)=x(i)+dx(i)
        y(i)=y(i)+dy(i)
        z(i)=z(i)+dz(i)
 289   continue
c
      do 340 i=1,im
        fxp(i)=fx(i)
        fyp(i)=fy(i)
        fzp(i)=fz(i)
 340  continue
c
      do 300 i=1,im
        rx(i)=0.0d0
        ry(i)=0.0d0
        rz(i)=0.0d0
        fx(i)=0.0d0
        fy(i)=0.0d0
        fz(i)=0.0d0
        uk(i)=0.0d0
        pl(1,i)=0.0d0
        pl(2,i)=0.0d0
        pl(3,i)=0.0d0
        pl(4,i)=0.0d0
        pl(5,i)=0.0d0
        pl(6,i)=0.0d0
 300  continue
c
c*****force calculation*********
c
      do 320 i=1,ik
c
        k1=kc(i,1)
        k2=kc(i,2)
        k3=kc(i,3)
        k4=kc(i,4)
        k5=kc(i,5)
        rx(k2)=x(k1)-x(k2)+dfloat(k3)*xl
        rx(k1)=-rx(k2)
c
        ry(k2)=y(k1)-y(k2)+dfloat(k4)*yl
        ry(k1)=-ry(k2)
c
        rz(k2)=z(k1)-z(k2)+dfloat(k5)*zl
        rz(k1)=-rz(k2)
c
        rd=rx(k2)*rx(k2)+ry(k2)*ry(k2)+rz(k2)*rz(k2)
c
       rd2 =rd/sigma/sigma ! r2
       rd = sqrt(rd)/sigma 
       fda=rd2*rd2*rd2  ! r6
       fdb=fda*fda      ! r12
       fd=(2.0d0/(fdb*rd)-1.0d0/(fda*rd))*24.0d0*epsilon
c
       fdx1=-fd*rx(k2)/rd
       fdy1=-fd*ry(k2)/rd
       fdz1=-fd*rz(k2)/rd
       fdx2=-fd*rx(k1)/rd
       fdy2=-fd*ry(k1)/rd
       fdz2=-fd*rz(k1)/rd
c !!! fdx1=-fdx2;fdy1=-fdy2;fdz1=-fdz2 
       fx(k2)=fx(k2)+fdx1
       fy(k2)=fy(k2)+fdy1
       fz(k2)=fz(k2)+fdz1
       fx(k1)=fx(k1)+fdx2
       fy(k1)=fy(k1)+fdy2
       fz(k1)=fz(k1)+fdz2
c
c   stress calculation
       pl(1,k1) =pl(1,k1) -fdx2*rx(k1)/2.0d0
       pl(2,k1) =pl(2,k1) -fdy2*ry(k1)/2.0d0
       pl(3,k1) =pl(3,k1) -fdz2*rz(k1)/2.0d0
       pl(4,k1) =pl(4,k1) -fdy2*rx(k1)/2.0d0
       pl(5,k1) =pl(5,k1) -fdz2*rx(k1)/2.0d0
       pl(6,k1) =pl(6,k1) -fdz2*ry(k1)/2.0d0
c
       pl(1,k2)=pl(1,k2)  -fdx1*rx(k2)/2.0d0
       pl(2,k2)=pl(2,k2)  -fdy1*ry(k2)/2.0d0
       pl(3,k2)=pl(3,k2)  -fdz1*rz(k2)/2.0d0
       pl(4,k2)=pl(4,k2)  -fdy1*rx(k2)/2.0d0
       pl(5,k2)=pl(5,k2)  -fdz1*rx(k2)/2.0d0
       pl(6,k2)=pl(6,k2)  -fdz1*ry(k2)/2.0d0
c  potential energy
       ud=(1.0d0/fdb-1.0d0/fda)*4.0d0*epsilon
       uk(k2)=uk(k2)+ud
       uk(k1)=uk(k1)+ud
  320  continue
c
c*******finite difference method***********
c
       do 350 i=1,im
        dvx(i)=(fxp(i)+fx(i))*dt/2.0d0/wm(i)
        dvy(i)=(fyp(i)+fy(i))*dt/2.0d0/wm(i)
        dvz(i)=(fzp(i)+fz(i))*dt/2.0d0/wm(i)
 350   continue
c
       do 360 i=1,im
          vx(i)=vx(i)+dvx(i)
          vy(i)=vy(i)+dvy(i)
          vz(i)=vz(i)+dvz(i)
 360    continue
c
       return
       end
