      subroutine calcu_fs
     &(im,ik,kc,x,y,z,vx,vy,vz,fx,fy,fz,wm,pl,uk,xl,yl,zl,dt)
      include 'para.inc'
c*******force calculation (not use if sentense) FS potential*********
      dimension x(im),y(im),z(im)
      dimension vx(im),vy(im),vz(im)
      dimension fx(im),fy(im),fz(im)
      dimension wm(im)
      dimension pl(6,im)
      dimension uk(im)
      dimension kc(kc1,kc2)
c
      dimension rx(im),ry(im),rz(im)
      dimension fxp(im),fyp(im),fzp(im)
      dimension dx(im),dy(im),dz(im)
      dimension fvx(im),fvy(im),fvz(im)
      dimension dvx(im),dvy(im),dvz(im)
      dimension fdensityx(im),fdensityy(im),fdensityz(im)
      dimension fdensityi(im),fdensityj(im)
      dimension density(im)
c
c*****initialize********
      do 300 i=1,im
        fx(i)=0.0d0
        fy(i)=0.0d0
        fz(i)=0.0d0
        uk(i)=0.0d0
        pl(1,i)=0.0d0
        pl(2,i)=0.0d0
        pl(3,i)=0.0d0
        pl(4,i)=0.0d0
        pl(5,i)=0.0d0
        pl(6,i)=0.0d0
 300  continue
c
        dvx=0.0d0
        dvy=0.0d0
        dvz=0.0d0
        fvx=0.0d0
        fvy=0.0d0
        fvz=0.0d0
        fdensityx=0.0d0
        fdensityy=0.0d0
        fdensityz=0.0d0
        fdensityi=0.0d0
        fdensityj=0.0d0
        density=0.0d0
c
c*****finite difference method*******
      do 299 i=1,im
       dx1=vx(i)+fx(i)*dt*0.5d0/wm(i)
       dy1=vy(i)+fy(i)*dt*0.5d0/wm(i)
       dz1=vz(i)+fz(i)*dt*0.5d0/wm(i)
       dx(i)=dx1*dt
       dy(i)=dy1*dt
       dz(i)=dz1*dt
 299  continue
c
      do 289 i=1,im
        x(i)=x(i)+dx(i)
        y(i)=y(i)+dy(i)
        z(i)=z(i)+dz(i)
 289   continue
c
      do 340 i=1,im
        fxp(i)=fx(i)
        fyp(i)=fy(i)
        fzp(i)=fz(i)
 340  continue
c
c*****force calculation*********
c  repulsive force
      do 320 i=1,ik
c
        k1=kc(i,1)
        k2=kc(i,2)
        k3=kc(i,3)
        k4=kc(i,4)
        k5=kc(i,5)
        rx(k2)=x(k1)-x(k2)+k3*xl
        rx(k1)=-rx(k2)
c
        ry(k2)=y(k1)-y(k2)+k4*yl
        ry(k1)=-ry(k2)
c
        rz(k2)=z(k1)-z(k2)+k5*zl
        rz(k1)=-rz(k2)
c
        rd1=dsqrt(rx(k2)*rx(k2)+ry(k2)*ry(k2)+rz(k2)*rz(k2))
cccc parameter for FS potential
c syoshin-sya no tame no bunshidourikigaku-hou youken-do p57
c*****calculation of repulsive force*******
       cut =  3.4d0
       c0  =  1.2371147d0
       c1  = -0.3592185d0
       c2  = -0.0385607d0
ccc repulsive force
       if(rd1.lt.cut) then
         fv=(rd1-cut)*(rd1-cut)*(c1+2.0d0*c2*rd1)
     &     +2.0d0*(rd1-cut)*(c0+c1*rd1+c2*rd1*rd1) 
         ud=(rd1-cut)*(rd1-cut)*(c0+c1*rd1+c2*rd1*rd1)
       else 
         fv=0.0d0
         ud=0.0d0
       endif
c
       fvdx1=-fv*rx(k2)/rd1
       fvdy1=-fv*ry(k2)/rd1
       fvdz1=-fv*rz(k2)/rd1
       fvdx2=-fvdx1
       fvdy2=-fvdy1
       fvdz2=-fvdz1
cccc repulsive force
       fvx(k1)=fvx(k1)+fvdx1
       fvy(k1)=fvy(k1)+fvdy1
       fvz(k1)=fvz(k1)+fvdz1
       fvx(k2)=fvx(k2)+fvdx2
       fvy(k2)=fvy(k2)+fvdy2
       fvz(k2)=fvz(k2)+fvdz2
c
       uk(k2)=uk(k2)+ud
       uk(k1)=uk(k1)+ud
c   stress calculation
       pl(1,k1) =pl(1,k1) -fvdx2*rx(k1)/2.0d0
       pl(2,k1) =pl(2,k1) -fvdy2*ry(k1)/2.0d0
       pl(3,k1) =pl(3,k1) -fvdz2*rz(k1)/2.0d0
       pl(4,k1) =pl(4,k1) -fvdy2*rx(k1)/2.0d0
       pl(5,k1) =pl(5,k1) -fvdz2*rx(k1)/2.0d0
       pl(6,k1) =pl(6,k1) -fvdz2*ry(k1)/2.0d0
c
       pl(1,k2)=pl(1,k2)  -fvdx1*rx(k2)/2.0d0
       pl(2,k2)=pl(2,k2)  -fvdy1*ry(k2)/2.0d0
       pl(3,k2)=pl(3,k2)  -fvdz1*rz(k2)/2.0d0
       pl(4,k2)=pl(4,k2)  -fvdy1*rx(k2)/2.0d0
       pl(5,k2)=pl(5,k2)  -fvdz1*rx(k2)/2.0d0
       pl(6,k2)=pl(6,k2)  -fvdz1*ry(k2)/2.0d0
c
  320  continue
c
c*****calculation of electric density term*******
       do  i=1,ik
c
        k1=kc(i,1)
        k2=kc(i,2)
        k3=kc(i,3)
        k4=kc(i,4)
        k5=kc(i,5)
        rx(k2)=x(k1)-x(k2)+k3*xl
        rx(k1)=-rx(k2)
c
        ry(k2)=y(k1)-y(k2)+k4*yl
        ry(k1)=-ry(k2)
c
        rz(k2)=z(k1)-z(k2)+k5*zl
        rz(k1)=-rz(k2)
c
c****inter atomic distance******
       rd=dsqrt(rx(k2)*rx(k2)+ry(k2)*ry(k2)+rz(k2)*rz(k2))
c
       b=1.8d0
       d=3.569745d0
       if(rd.lt.d) then
       densityi=(rd-d)*(rd-d)+b*(rd-d)*(rd-d)*(rd-d)/d
       else 
         densityi=0.0d0
       endif 
cccc rho
        density(k2)=density(k2)+densityi
        density(k1)=density(k1)+densityi
       end do
c
cccc 1/(2*sqrt(rho))
      paraa=1.828905d0
      do i=1,im
        fdensityi(i)=0.5d0/dsqrt(density(i))
       uk(k2)=uk(k2) -  paraa*sqrt(density(i))
       uk(k1)=uk(k1) -  paraa*sqrt(density(i))
      end do
c
c******attractive force********
      do 330 i=1,ik
c
        k1=kc(i,1)
        k2=kc(i,2)
        k3=kc(i,3)
        k4=kc(i,4)
        k5=kc(i,5)
        rx(k2)=x(k1)-x(k2)+k3*xl
        rx(k1)=-rx(k2)
c
        ry(k2)=y(k1)-y(k2)+k4*yl
        ry(k1)=-ry(k2)
c
        rz(k2)=z(k1)-z(k2)+k5*zl
        rz(k1)=-rz(k2)
c
c****interatomic distance******
        rd2=dsqrt(rx(k2)*rx(k2)+ry(k2)*ry(k2)+rz(k2)*rz(k2))
c
       b=1.8d0
       d=3.569745d0
       if(rd.lt.d) then
         densityj=(rd-d)*(rd-d)+b*(rd-d)*(rd-d)*(rd-d)/d
         den=2.0d0*(rd-d)+3.0d0*b*(rd-d)*(rd-d)/d
c
         fdensityj(k1)=0.5d0/dsqrt(densityj)
         fdensityj(k2)=0.5d0/dsqrt(densityj)
       else
         densityj=0.0d0 
         den=0.0d0
         fdensityj(k1)=0.0d0
         fdensityj(k2)=0.0d0 
       endif 
c 
      paraa=1.828905d0
      fdensitydx1=paraa*(fdensityi(k1)+fdensityi(k2))*den*rx(k2)/rd
      fdensitydy1=paraa*(fdensityi(k1)+fdensityi(k2))*den*ry(k2)/rd
      fdensitydz1=paraa*(fdensityi(k1)+fdensityi(k2))*den*rz(k2)/rd
      fdensitydx2=paraa*(fdensityi(k1)+fdensityi(k2))*den*rx(k1)/rd
      fdensitydy2=paraa*(fdensityi(k1)+fdensityi(k2))*den*ry(k1)/rd
      fdensitydz2=paraa*(fdensityi(k1)+fdensityi(k2))*den*rz(k1)/rd
c
       fdensityx(k1)=fdensityx(k1)+fdensitydx1
       fdensityy(k1)=fdensityy(k1)+fdensitydy1
       fdensityz(k1)=fdensityz(k1)+fdensitydz1
       fdensityx(k2)=fdensityx(k2)+fdensitydx2
       fdensityy(k2)=fdensityy(k2)+fdensitydy2
       fdensityz(k2)=fdensityz(k2)+fdensitydz2
c
c stress calculation
c
c   stress calculation
       pl(1,k1) =pl(1,k1) -fdensitydx2*rx(k1)/2.0d0
       pl(2,k1) =pl(2,k1) -fdensitydy2*ry(k1)/2.0d0
       pl(3,k1) =pl(3,k1) -fdensitydz2*rz(k1)/2.0d0
       pl(4,k1) =pl(4,k1) -fdensitydy2*rx(k1)/2.0d0
       pl(5,k1) =pl(5,k1) -fdensitydz2*rx(k1)/2.0d0
       pl(6,k1) =pl(6,k1) -fdensitydz2*ry(k1)/2.0d0
c
       pl(1,k2)=pl(1,k2)  -fdensitydx1*rx(k2)/2.0d0
       pl(2,k2)=pl(2,k2)  -fdensitydy1*ry(k2)/2.0d0
       pl(3,k2)=pl(3,k2)  -fdensitydz1*rz(k2)/2.0d0
       pl(4,k2)=pl(4,k2)  -fdensitydy1*rx(k2)/2.0d0
       pl(5,k2)=pl(5,k2)  -fdensitydz1*rx(k2)/2.0d0
       pl(6,k2)=pl(6,k2)  -fdensitydz1*ry(k2)/2.0d0
c
c
  330 continue 
c  
c  total force
      do 360 i=1,im
       fx(i)=(fvx(i)+fdensityx(i))
       fy(i)=(fvy(i)+fdensityy(i))
       fz(i)=(fvz(i)+fdensityz(i))
  360 continue            
c
c  finite difference method
c
       do 350 i=1,im
        dvx(i)=(fxp(i)+fx(i))*dt/2.0d0/wm(i)
        dvy(i)=(fyp(i)+fy(i))*dt/2.0d0/wm(i)
        dvz(i)=(fzp(i)+fz(i))*dt/2.0d0/wm(i)
  350  continue
c
       do  i=1,im
          vx(i)=vx(i)+dvx(i)
          vy(i)=vy(i)+dvy(i)
          vz(i)=vz(i)+dvz(i)
       enddo
       
       return
       end







