c*******book-keeping *****
      subroutine pcopyf(im,n,ik,kc,x,y,z,xl,yl,zl,rcut,dt)
      include 'para.inc'
      dimension x(im),y(im),z(im)
      dimension kc(kc1,kc2)
ccccc local variable
      dimension rx(im),ry(im),rz(im)
      dimension rr(kc1)
c
      ks=0
c
      do j=1,im-1
      do i=j+1,im
c
c******setting of periodic boundary condition using sign function
       ry0=y(j)-y(i)
       ry1=y(j)-y(i)+yl
       ry2=y(j)-y(i)-yl
       sy0=(dsign(1.0d0,yl/2.0d0-dabs(ry0))+1)/2.0d0
       sy1=(dsign(1.0d0,yl/2.0d0-dabs(ry1))+1)/2.0d0
       sy2=(dsign(1.0d0,yl/2.0d0-dabs(ry2))+1)/2.0d0
c       write(6,*)i,j,y(i),y(j),ry0,ry1,ry2
c if an atom locates on the center of cell dabs(1-sy0-sy1-sy2)=1
       ry(i)=sy0*ry0+sy1*ry1+sy2*ry2+dabs(1-sy0-sy1-sy2)*yl/2.0d0
c
       ry(j)=-ry(i)
c
       if (sy0.eq.1.0d0) ky=0
       if (sy1.eq.1.0d0) ky=1
       if (sy2.eq.1.0d0) ky=-1
c
c******setting of periodic boundary condition not using sign function
       rx0=x(j)-x(i)
       rx1=x(j)-x(i)+xl
       rx2=x(j)-x(i)-xl
       sx0=(dsign(1.0d0,xl/2.0d0-dabs(rx0))+1)/2.0d0
       sx1=(dsign(1.0d0,xl/2.0d0-dabs(rx1))+1)/2.0d0
       sx2=(dsign(1.0d0,xl/2.0d0-dabs(rx2))+1)/2.0d0
c
c
       rx(i)=sx0*rx0+sx1*rx1+sx2*rx2+dabs(1-sx0-sx1-sx2)*xl/2.0d0
       rx(j)=-rx(i)
c     
       if (sx0.eq.1.d0) kx=0
       if (sx1.eq.1.d0) kx=1
       if (sx2.eq.1.d0) kx=-1
c
c******setting of periodic boundary condition using sign function
       rz0=z(j)-z(i)
       rz1=z(j)-z(i)+zl
       rz2=z(j)-z(i)-zl
       sz0=(dsign(1.0d0,zl/2.0d0-dabs(rz0))+1)/2.0d0
       sz1=(dsign(1.0d0,zl/2.0d0-dabs(rz1))+1)/2.0d0
       sz2=(dsign(1.0d0,zl/2.0d0-dabs(rz2))+1)/2.0d0
c if an atom locates on the center of cell dabs(1-sy0-sy1-sy2)=1
       rz(i)=sz0*rz0+sz1*rz1+sz2*rz2+dabs(1-sz0-sz1-sz2)*zl/2.0d0
c
       rz(j)=-rz(i)
c
       if (sz0.eq.1.0d0) kz=0
       if (sz1.eq.1.0d0) kz=1
       if (sz2.eq.1.0d0) kz=-1
c
c******************************************************************
c  interatomic distance
       rd=rx(i)*rx(i)+ry(i)*ry(i)+rz(i)*rz(i)
       rd = sqrt(rd)
c************************************************
c
c  cutoff distance = rcut
c
       if (rd.gt.rcut) then
       else
         ks=ks+1
c
c    kc(i,1) : 1st booking atom 
c    kc(i,2) : 2nd booking atom 
c    kc(i,3) : boundary condition of x-direction (-1 or 0 or 1) 
c    kc(i,4) : boundary condition of y-direction (-1 or 0 or 1) 
c    kc(i,5) : boundary condition of z-direction (-1 or 0 or 1) 
c
c     atom i
         kc(ks,1)=j
c     atom j
         kc(ks,2)=i
c     periodic bounday of x-direction
         kc(ks,3)=kx
c     periodic bounday of y-direction
         kc(ks,4)=ky
c     periodic bounday of y-direction
         kc(ks,5)=kz
c     distance
         rr(ks)=rd
       endif
c
       enddo
       enddo
c
        ik=ks
c
      nbook_out=100000
c      nbook_out=100
c    output book information
       if ((n.ne.0).and.(mod(n,nbook_out).eq.0)) then
       open(14,file='cutoff.dat')
c
        write(14,'(i5)')ik
        do i=1,ik
         write(14,'(2i5,3i2,e12.3)')
      &  kc(i,1),kc(i,2),kc(i,3),kc(i,4),kc(i,5),rr(i)
        enddo
        close(14)
       endif
c
       return
       end
